<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <script>
      $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gEFirstName = $("#inp-first-name");
        var gELastName = $("#inp-last-name");
        var gEAge = $("#inp-age");

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        $("#btn-submit-data").click(onBtnSubmitDataClick);
        $("#btn-clear-log").click(function () {
          $("#p-html-log").html(">");
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm thực thi khi nút Submit Data được ấn
        function onBtnSubmitDataClick() {
          //B1: get data
          var vDataObj = getFormData();
          //B2: Validate data
          var vCheck = validateFormData(vDataObj);
          if (vCheck) {
            hienThiDuLieu(vDataObj);
          }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm thu thập dữ liệu
        function getFormData() {
          var vDataObj = new Object();

          vDataObj.firstname = $.trim(gEFirstName.val());
          vDataObj.lastname = $.trim(gELastName.val());
          vDataObj.age = $.trim(gEAge.val());

          return vDataObj;
        }

        //hàm kiểm tra dữ liệu
        function validateFormData(paramDataObj) {
          if (paramDataObj.firstname == "") {
            alert("Bạn cần điền first name");
            console.log("Dữ liệu không hợp lệ");
            return false;
          }

          if (paramDataObj.lastname == "") {
            alert("Bạn cần điền last name");
            console.log("Dữ liệu không hợp lệ");
            return false;
          }

          if (paramDataObj.age == "") {
            alert("Bạn cần điền age");
            console.log("Dữ liệu không hợp lệ");
            return false;
          }
          if (isNaN(paramDataObj.age)) {
            alert("tuổi phải là số");
            console.log("Dữ liệu không hợp lệ");
            return false;
          }
          if (paramDataObj.age <= 0 || paramDataObj.age >= 200) {
            alert("tuổi phải > 0 và < 200");
            console.log("Dữ liệu không hợp lệ");
            return false;
          }

          return true;
        }

        //hàm hiển thị dữ liệu
        function hienThiDuLieu(paramDataObj) {
          $("#p-html-log").append(`
            Firstname: ${paramDataObj.firstname}<br/>
            Lastname: ${paramDataObj.lastname}<br/>
            Age: ${paramDataObj.age}<br/><br/>
          `);
        }
      });
    </script>
  </head>

  <body>
    <div class="container">
      <h2 style="text-align: center;">Personal Data Submit Form</h2>

      <div class="jumbotron container">
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="input-first-name">First Name</label>
          </div>
          <div class="col-sm-9">
            <input
              type="text"
              id="inp-first-name"
              name="firstname"
              placeholder="Your first name ..."
              class="form-control"
            />
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="inp-last-name">Last Name</label>
          </div>
          <div class="col-sm-9">
            <input
              type="text"
              id="inp-last-name"
              name="lastname"
              placeholder="Your last name.."
              class="form-control"
            />
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="age">Age</label>
          </div>
          <div class="col-sm-9">
            <input
              type="number"
              id="inp-age"
              name="age"
              placeholder="Your age ..."
              class="form-control"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12" style="text-align: right;">
            <button id="btn-submit-data" class="btn btn-info">
              Submit Data
            </button>
          </div>
        </div>
      </div>
      <!-- HTML Log -->
      <hr />
      <div style="text-align: right;">
        <button id="btn-clear-log" class="btn btn-info">Clear HTML Log</button>
      </div>
      <p id="p-html-log"></p>
    </div>
  </body>
</html>
